On the number of clusterings in a hierarchical classification model ...

S C H E D A EI N F O R M A T I C A EVOLUME 20 2011**On** **the** **number** **of** **cluster ings**

138We have proposed a different approach to **the** above problem by means **of** aHierarchical Classifier (HC) algorithm **in** which **the** tra**in****in**g set is, upon build**in**gsubsequent classifiers, divided **in**to overlapp**in**g subsets, which def**in**e subproblems tobe solved [3].Def**in**ition 1. For a tra**in****in**g set D = {(att i , x i )} N i=1 , x i ∈ K = {1, 2, . . . , K}, whereK is **the** set **of** classes, a Hierarchical Classifier HC is def**in**ed as a tree structure1. **the** root classifier Cl 0 is a weak classifier **in**to K classes2. a cluster**in**g algorithm groups classes which were similarly classified by Cl 0 **in**toset **of** J clusters C = {C 1 , . . . , C J }, C j ⊂ K,3. for each cluster C j• a new tra**in****in**g set D j = {(att i , x i ) ∈ D : x i ∈ C j } is extracted from **the**orig**in**al set D• a new classifier Cl j is built **in** **the** same way.HC may be built recursively until a low error is achieved. After HC is tra**in**ed, **the**output class for an **in**put vector att is found us**in**g **the** follow**in**g formula Cl(att) =arg max i∈K Cl(i|att), whereCl(i|att) = ∑j:i∈C jCl mod (C j |att)Cl j (i|att) (1)and Cl mod (C j |att) stands for **the** probability **of** **the** selection **of** cluster C j , providedthat **the** vector att is given **in**to **the** classifier’s **in**put. Cl j is a classifier associatedwith cluster C j (that is, it is able to recognize only classes that belong to C j ).By Cl j (i|att) we mean **the** activation **of** Cl j for i-th class, given att vector as **the**classifier’s **in**put. If a given classifier Cl does not divide its problem **in**to subproblems(i.e. Cl is a leaf **in** **the** classifiers tree), its answer is just a probability vector:Cl(att) = [p(1)...p(K)].A two level HC is depicted **in** Figure 1. The crucial part **of** **the** HC construction is**the** cluster**in**g process. It is important to note, that **the** clusters **in** HC may overlap,i.e. ∃ i, j, i ≠ j : C i ∩ C j ≠ ∅, none is a subset **of** ano**the**r cluster, and none iscomposed **of** all classes from K. Thus, it can be shown that addition **of** classifierlayer results **in** low error.When study**in**g **the** properties **of** HC, it became apparent that **the** overall accuracydepends on **the** cluster**in**g found **in** **the** algorithm, reflected **in** **the** correctvalue found with Cl mod . The actual **cluster ings** are found us

139Fig. 1. The Hierarchical Classifier HC2. Problem formulationLet us formulate **the** **cluster ings** count

1403. Case J = 2The case for J = 2 is easy to solve:Theorem 3.where S(K, 3) is **the** Stirl**in**g **number** **of** **the** second k**in**d.ϑ(K, 2) = 3S(K, 3), (8)Pro**of**. Consider any partition **of** K-element set **in**to 3 nonempty subsets C 1 ,C 2 , C 3 . Such a partition def**in**es three different proper (K, 2)-**cluster ings**: C 1 ={C 1 ∪ C 2 , C 1 ∪ C 3 }, C 2 = {C 1 ∪ C 2 , C 2 ∪ C 3 }, and C 3 = {C 1 ∪ C 3 , C 2 ∪ C 3 }.

141Proposition 5. Let C and C ′ be **the** families from Def**in**ition 4. If x K+1 belongs toexactly one subset **of** C ′ , **the**n ∑ Ji=1 |C i| > K.Pro**of**. Contrarily, suppose ∑ Ji=1 |C i| = K. Then C is a partition **of** K. But x K+1belongs only to one element **of** C ′ , so C ′ is also a partition – a contradiction with(K + 1, J)-cluster**in**g **of** C ′ . □Proposition 6. If C = {C 1 , . . . , C J } is an extendable family, **the**n all C i ’s aredifferent.Pro**of**. Let C ′ be a family formed from C by add**in**g a new element to someelements **of** C. Suppose contrarily that **the**re exist i, j, i ≠ j, such that C i = C j .But **the**n, after add**in**g a new x K+1 element, **in** C ′ **the**re exist two different elementsD 1 , D 2 such that D 1 = C 1 or D 1 = C 1 ∪{x K+1 } and D 2 = C 2 or D 2 = C 2 ∪{x K+1 }.In each **of** **the**se four situations ei**the**r D 1 = D 2 or D 1 ⊂ D 2 or D 2 ⊂ D 1 – acontradiction with (K + 1, J)-cluster**in**g **of** C ′ . □A proper (K + 1, J)-cluster**in**g can be build by add**in**g a new x K+1 elementto some subsets **of** an extendable (K, J)-family over K = {x 1 , . . . , x K }. For someextendable (K, J)-families over K, add**in**g a new element can be done **in** more thanone way.Lemma 7 characterizes **the** extendable (K, J)-families.Lemma 7. Let C = {C 1 , . . . , C J } be an extendable (K, J)-family over K = {x 1 ,. . . , x K }. Then C has exactly one **of** **the** follow**in**g four properties:(P1) C is a proper (K, J)-cluster**in**g;(P2) C is an improper (K, J)-cluster**in**g;(P3) C is a partition **of** K-element set **in**to J nonempty subsets;(P4) C is a (K, J)-cluster**in**g with **in**clusion, such that C i ⊆ C j ⊆ C k ⇒ i = j ∨ j =k.Pro**of**. It is clear that C cannot have two or more properties (P1)–(P4). LetD = {D 1 , . . . , D J } be a proper (K + 1, J)-cluster**in**g. We will show that remov**in**gmax( ⋃ D) = x K+1 from all subsets **of** D gives us a family with one **of** **the** properties(P1)–(P4). Let δ = |{D i : x K+1 ∈ D i }|, ε = max j∈{1,...,J} {|{D i : j ∈ D i }|}. It isclear that both δ ≥ 1 and ε ≥ 1. Consider three possible cases:Case 1. δ = 1. From Proposition 5 ε > 1, so **in** C **the**re exist C 1 , C 2 , C 1 ≠ C 2 such thatC 1 ∩ C 2 ≠ ∅. If C 1 ⊂ C 2 , **the**n from Proposition 6 it is a strict **in**clusion andbecause δ = 1, no two o**the**r subsets rema**in** **in** **the** **in**clusion relation. In thissituation C has property (P4). If no two subsets are **in** **the** **in**clusion relation,**the**n C has property (P1) or (P2).Case 2. ε = 1. Then C must be a partition and **the**refore has property (P3).Case 3. δ > 1, ε > 1. The case reduces to Case 1 or **the**re is more than one pair **of** setsC i , C j such that C i ⊂ C j . Such a family cannot have properties (P1)–(P3).Because **of** extendability, C must have **the** property (P4). □

142Lemma 7 gives us **the** complete list **of** ways **in** which a proper (K+1, J)-cluster**in**gcan be formed. The only th**in**g to do is to count **the** **number** **of** extendable familieswith properties (P1)–(P4) and, for each **of** **the**m, **the** **number** **of** ways **in** which a newx K+1 th element can be added to form a proper (K + 1, J)-cluster**in**g.5. Case J = 3We will use Lemma 7 to count **the** **number** **of** ways to extend each extendable family**in**to a proper (K + 1, 3)-cluster**in**g.Lemma 8. Let K ≥ 3. There exist 7ϑ(K, 3) proper (K + 1, 3)-**cluster ings** created byextend

143Case 2. |C 1 | = 1, |C 2 | > 1, |C 3 | > 1. Let K ≥ 5. C 1 can be chosen **in** K ways.∑C 2 and C 3 form a partition **of** a K − 1-element set. C 2 can be chosen **in**K−3( K−1)i=2 i = 2 K−1 − 2K ways, **the**n C 3 is uniquely determ**in**ed. Because**the** order **of** C 2 and C 3 is not important, we must divide **the** value by 2, sowe have β = K 2 (2K−1 − 2K) partitions with exactly one s**in**gleton. For eachsuch an extendable family x K+1 can be added **in** 3 ways: it must be added toC 1 and it must be added to at least one **of** **the** sets C 2 , C 3 . F**in**ally, we obta**in**3K2 (2K−1 − 2K) = 3K 4 2K − 3K 2 ways to create a proper (K + 1, 3)-cluster**in**g.Case 3. |C i | > 1 ∀i = 1, 2, 3. Let K ≥ 6. For K ≥ 6 **the**re are S(K, 3) − α − β suchpartitions. For each **of** **the**m, x K+1 must be added to at least two subsets, sowe have 4 possibilities **of** do**in**g this and 4(S(K, 3) − α − β) = 2 3 · 3K − (K +2) · 2 K + 2K 2 + 2K + 2 proper (K + 1, J)-**cluster ings**.Gett

144set **of** all conditions and **the** correspond**in**g algebraic relations are given below.C 1 C 2 ⇒ B + E > 0 (9)|C 1 | ≥ 1 ⇒ A + C > 0 (10)C 3 ⊄ C 1 ⇒ B + D > 0 (11)C 2 ⊄ C 3 ⇒ C + E > 0 (12)¬(C 1 ⊆ C 3 ⊆ C 2 ) ⇒ C + D > 0. (13)Conditions (9) and (10) come directly from **the** assumptions on **the** (K, 3)-family.Conditions (11)–(13) come from **the** property (P4) which says that 3 different sets **in**C cannot form a descend**in**g family (w.r.t. **the** **in**clusion). We will count **the** **number****of** vectors fulfill**in**g (9)–(13). There are 12 possible cases (see Fig. 2):(BC) C 3 = C 2 \ C 1 ,(ABC) C 2 = C 1 ∪ C 3 , C 1 ∩ C 3 ≠ ∅,(ADE) C 2 \ C 3 ≠ ∅, C 3 \ C 2 ≠ ∅, C 2 ∩ C 3 = C 1 ,(BCD) C 2 C 1 ∪ C 3 , C 1 ∩ C 3 = ∅,(BCE) C 1 ∩ C 3 = ∅, C 1 ∪ C 3 C 2 ,(CDE) C 3 ∩ C 2 = ∅,(ABCD) C 3 ∩ C 1 ≠ ∅, C 1 \ C 3 ≠ ∅, C 2 \ C 1 C 3 , C 3 \ C 2 ≠ ∅,(ABCE) C 3 ∩ C 1 ≠ ∅, C 3 C 2 ,(ABDE) C 1 C 3 , C 3 ∩ (C 2 \ C 1 ) ≠ ∅, C 3 \ C 2 ≠ ∅,(ACDE) C 3 ∩ C 1 ≠ ∅, C 1 \ C 3 ≠ ∅, C 3 ∩ (C 2 \ C 1 ) = ∅, C 3 \ C 2 ≠ ∅,(BCDE) C 3 ∩ C 1 = ∅, C 3 ∩ C 2 ≠ ∅, C 3 \ C 2 ≠ ∅, C 2 \ (C 1 ∪ C 3 ) ≠ ∅,(ABCDE) C 3 ∩ C 1 ≠ ∅, C 1 \ C 3 ≠ ∅, C 3 ∩ (C 2 \ C 1 ) ≠ ∅, C 2 \ (C 1 ∪ C 3 ) ≠ ∅,C 3 \ C 2 ≠ ∅.If vector p falls under **the** case (X), we will say that p is **of** type (X). The case**number** symbolically describe **the** set **of** allowed values **in** p fall**in**g under that case.For example, if p is **of** type (BC), **the**n p conta**in**s only B’s and C’s and B, C > 0.Note, that **in** some cases two different vectors can represent **the** same (K, 3)-family.This case holds if **the**re is a ”symmetry” between C 1 and C 3 or between C 2 andC 3 . For example, vectors (A, B, C) and (A, C, B) represent one family **in** two ways:**in** **the** first x 2 ∈ C 3 , x 3 ∈ C 1 and **in** **the** second x 2 ∈ C 1 , x 3 ∈ C 3 . After chang**in**gC 1 with C 3 **the** structure **of** **the** family rema**in**s **the** same. Such a symmetry occurs**in** cases (BC), (ABC), (ADE), (BCE), (ABCE) and (ABDE), so **in** each **of** **the**secases **the** **number** **of** all different vectors **of** a given type must be divided by 2. Letα(X) denote **the** **number** **of** proper (K + 1, 3)-**cluster ings** created from (K, 3)-family

145Fig. 2. All possible casesand must be added to C 1 , because **of** **in**clusion C 1 C 2 . Therefore, **the** **number** **of**ways **of** creat**in**g a proper (K + 1, 3)-cluster**in**g from a given family depends only on**the** fact whe**the**r we have to add x K+1 to C 3 or we may do this. In **the** first case**the**re is only one way to create a proper cluster**in**g; **in** **the** second one **the**re are twoways **of** do**in**g that.Case (BC). There are 2K −22different (K, 3)-families **of** type (BC). In order toextend it **in**to a proper (K + 1, 3)-family we must add x K+1 to C 3 ; **the**refore we cando it **in** only one way, so α(BC) = 1 · 2K −22.Cases (ABC), (ADE) and (BCE). These cases are identical modulo ) type names.2 K + ( 3From **the** **in**clusion-exclusion pr**in**ciple we have that **the**re are 3 K − ( 32 1)vectors**of** type (ABC). In cases (ABC) and (BCE) x K+1 must be added to C 3 ; **in** (ADE)it cannot be added, **the**refore **in** each **of** **the**se cases **the**re is only one possibility **of**add**in**g x K+1 . Because **of** **the** symmetry between C 1 and C 3 **in** (ABC) and (BCE)and between C 2 and C 3 **in** (ADE) we have α(ABC) = α(ADE) = α(BCE) =−(1 · 3K 3 2)2 K +( 3 1)2.Case (BCD). x K+1 can be added or not to C 3 ; **the** case is not a symmetric one,so α(BCD) = 2α(ADE).Case (CDE). This is a nonsymmetric case. Consider two subcases: |C 3 | = 1 and|C 3 | > 1. If |C 3 | = 1, **the**n we must add x K+1 to C 3 and **the**re are 1 · K(2 K−1 − 2)vectors **of** this type. If |C 3 | > 1 **the**n x K+1 can be added or not to C 3 and **the**re are∑ K−2( K)i=2 i (2 K−i −2) vectors **of** this type (here i goes through **the** **number** **of** elements**in** C 3 ). Eventually, we have α(CDE) = K(2 K−1 − 2) + 2 · ∑K−2 )i=2 (2 K−i − 2) =2 · 3 K − ( K 2 + 6) · 2K + 2K + 6.Cases (ABCD), (ACDE) and (BCDE). These are nonsymmetric cases, identicalmodulo type names, and x K+1 can be added or not to C 3 . We have α(ABCD) =α(ACDE) = α(BCDE) = 2(4 K − ( 43)3 K + ( )42 2 K − ( 41)).( Ki

146Cases (ABCE) and (ABDE). We have a symmetry between C 1 and C 3 **in** (ABCD)and between C 2 and C 3 **in** (ABDE). The new x K+1 element must be added to C 3 **in**(ABCE) and cannot be added to C 3 **in** (ABDE). In both cases **the**re is only one way−(to create a proper cluster**in**g and α(ABCE) = α(ABDE) = 4K 4 3)3 K +( 4 2)2 K −( 4 1)2.Case (ABCDE). In this nonsymmetric case x K+1 can be added or not to C 3 , soα(ABCDE) = 2(5 K − ( )54 4 K + ( )53 3 K + ( )52 2 K − ( 51)).Let I be **the** set **of** all 12 possible types. Gett**in**g all **the** cases toge**the**r we obta**in**∑α(X) = 2 · 5 K − 3 · 4 K − 5 2 · 3K +X∈I(6 − K 2)· 2 K + 2K − 5 2 ,and notice that **the** formula is also valid for K = 4, 5, **the**refore it is valid for eachK ≥ 4. This ends **the** pro**of** **of** Lemma 10. □Now we are ready to state **the** ma**in** **the**orem.Theorem 12.ϑ(3, 3) = 1ϑ(K + 1, 3) = 7ϑ(K, 3) + 2 · 5 K − 3 · 4 K +where K ≥ 3.+9K − 1 2 ,4K − 116· 3 K + (4 − 15K4 ) · 2KPro**of**. The pro**of** comes directly by apply**in**g Lemmata 7 and 8–11. □In Tab. 1 some values **of** **the** ϑ(K, 3) are given. It can be noticed, that **the** growthrate is exponential and is O(n K ) where n is **the** **number** **of** all properties **of** elements**of** multi-characteristic vector p(C) (see Lemma 11). It can be easily shown that forarbitrary J ≥ 3 value n = 2 J−1 + 2 J−2 + 1. In o**the**r words, **the** exponent **in** **the**growth rate is **the** multiple **of** **number** **of** clusters J and **number** **of** classes K.Tab. 1. Some first values **of** ϑ(K, 3).K 3 4 5 6 7 8 9 10ϑ(K, 3) 1 38 675 7 840 74 291 630 546 5 014 843 38 290 5806. Algorithm for **cluster ings** generation for J = 3Generation

148Algorithm 3 GenPartitionCluster**in**gs1: INPUT: X = {x 1 , . . . , x K }2: OUTPUT: Q – **the** set **of** all (K, 3)-proper **cluster ings** created from extendable(K − 1, 3) families with property (P3).3: if K < 3

1497. Dedek**in**d problemThe Dedek**in**d problem concerns determ**in****in**g exact formula for **the** **number** **of** monotonicboolean functions with fixed **number** **of** variables. These **number**s – known asDedek**in**d **number**s – form a rapidly grow**in**g sequence (denoted by ψ(n) where nis **the** **number** **of** function variables) and also def**in**e **the** **number**s **of** anticha**in**s **of**n-element set.Let us **in**troduce **the** necessary def**in**itions.Def**in**ition 13. A partially ordered set is a pair P = (X, ⊑) where X is a setand ⊑ is a b**in**ary relation over X which fulfils follow**in**g conditions:1. ∀ x∈X x ⊑ x (reflexivity),2. ∀ x,y∈X x ⊑ y ∧ y ⊑ x ⇒ x = y (antisymmetry),3. ∀ x,y,z∈X x ⊑ y ∧ y ⊑ z ⇒ x ⊑ z (transitivity).An example **of** partially ordered set is a power set with **in**clusion relation.Def**in**ition 14. A cha**in** **in** a partially ordered set P = (X, ⊑) is a subset A **of** setX whose any pair **of** elements are comparable, i.e.∀ x,y∈A x ⊑ y ∨ y ⊑ x.Def**in**ition 15. An anticha**in** **in** a partially ordered set P = (X, ⊑) is a subset A**of** set X **in** which any two elements are not comparable, i.e.∀ x,y∈A x ⋢ y ∧ y ⋢ x.Def**in**ition 16. A boolean function is a function f : X → Y , where X ⊂ {0, 1} nand Y ⊂ {0, 1}. A boolean function is called monotonic if∀ a1,...,a n,b 1,...,b n∈{0,1} a 1 b 1 , . . . , a n b n ⇒ f(a 1 , . . . , a n ) f(b 1 , . . . , b n ).Monotonic boolean functions are an important class **of** boolean functions. Theircharacteristic is that **the**y can be def**in**ed by composition **of** logical conjunctions anddisjunctions, but not negations.The problem **of** determ**in****in**g ψ(n) was formulated **in** 1897 by Richard Dedek**in**d[7]. He solved it for values n 4. In 1940 Church [8] presented **the** solution forn = 5, whereas Ward [9] for n = 6.More general properties were proved later. In 1953 Yamamoto [10] showed thatψ(n) is even for even values **of** n. In 1954 Gilbert [11] proved **the** **in**equalitywhile Yamamoto [12]log 2 ψ(n)

150In [13] Korobkov improved **the** upper bound **of** ψ(n) for 2 4.23( [n/2]) n. In 1966Hansel [14] managed to move it to 3 ( [n/2]) n.In Kleitman’s paper [15] it is shown that2 (1+αn)( [n/2]) n ψ(n) 2(1+β n)( [n/2]) n,where α n = ce − n 4 , β n = c ′ (log n)/n 1 2 .The more precise estimation was reached by Korshunov [16]:(( ) (ψ(n) ∼ 2 ( [n/2]) nn 1expn2 − 1 2 n 2+ n22 n+5 − n2 n+4 ))for even n and(( ) ( ) )ψ(n) ∼ 2 · 2 (n(n−1)/2)nnexp a(n) +b(n)(n − 3)/2 (n − 1)/2for odd n, wherewhereas1 n2a(n) = −2(n−3)/2 2 n+6 − n1 n2b(n) = +2(n+1)/2 2 n+4 .2 n+3The exact formula **of** Dedek**in**d **number**s was obta**in**ed by Kisielewicz [17]:∑ψ(n) =2 2n2∏n −1k=1 j=1 i=0⎛j−1∏⎝1 − b k i b k jlog 2 i∏m=0⎞(1 − bim + b i mb j m)⎠ ,where b k i = [k/2 i ] − 2[k/2 i+1 ]. Unfortunetely, it requires too much calculation toprove usable for n > 5.Similar result was presented **in** [18]:∑ψ(n) =2 2n2∏n −1k=1 j=1 i=0⎛j−1∏⎝1 − b k i( ) log ∏2 i1 − bkjm=0⎞( ( ))1 − bim 1 − bjm⎠ .Despite **the** differences ((1 − b k j ) **in**stead **of** bk j ) both formulas give **the** same values.The first one was found by count**in**g anticha**in**s and **the** second by monotonic booleanfunctions (and this was **the** source **of** **the** difference).Values **of** Dedek**in**d **number**s known today are presented **in** Table 2.**On**e **of** general methods **of** count**in**g monotonic boolean functions **of** n variablesis to divide **the**m **in**to smaller, disjo**in**t groups and to count objects **in** every group.Two sample **classification** criteria [21] are presented below.

151Tab. 2. Known values **of** Dedek**in**d **number**s.n ψ(n) Who0 2 R.Dedek**in**d, 1897 [7]1 3 R.Dedek**in**d, 1897 [7]2 6 R.Dedek**in**d, 1897 [7]3 20 R.Dedek**in**d, 1897 [7]4 168 R.Dedek**in**d, 1897 [7]5 7581 R. Church, 1940 [8]6 7828354 M. Ward, 1946 [9]7 2414682040998 R. Church, 1965 [19]8 56130437228687557907788 D. Wiedemann, 1991 [20]Tab. 3. Number **of** monotonic boolean functions mapp**in**g determ**in**ed **number** **of****in**put states **in**to 1 for n = 3.k **number** **of** functions0 11 12 33 34 45 36 37 18 1Total: 207.1. Number **of** **in**put states which are mapped **in**to 1.Hav**in**g determ**in**ed **the** **number** **of** doma**in**’s elements (denoted by k, where k ∈{0, . . . , 2 n }) we count monotonic functions which map **in**to 1 exactly that **number****of** **in**put states.Sample values for n = 3, 4, 5 are presented **in** Tabs resp. 3, 4, 5.As can be seen, **the** partition is symmetrical.7.2. Additional parameterHav**in**g **the** second parameter (determ**in****in**g **the** **number** **of** sets **in** **the** anticha**in**) fixed,it is possible to obta**in** **the** exact formula for Dedek**in**d **number**:

152Tab. 4. Number **of** monotonic boolean functions mapp**in**g determ**in**ed **number** **of****in**put states **in**to 1 for n = 4.k **number** **of** functions0 11 12 43 64 105 136 187 198 249 1910 1811 1312 1013 614 415 116 1Total: 168Tab. 5. Number **of** monotonic boolean functions mapp**in**g determ**in**ed **number** **of****in**put states **in**to 1 for n = 5.k **number** **of** events with k states k **number** **of** events with k states0 1 17 6051 1 18 5802 5 19 5303 10 20 4704 20 21 3875 35 22 3106 61 23 2157 95 24 1558 155 25 959 215 26 6110 310 27 3511 387 28 2012 470 29 1013 530 30 514 580 31 115 605 32 116 621 Total: 7581

153ψ(n, 0) = 1,ψ(n, 1) = 2 n ,ψ(n, 2) = 2 n · 2n − 12ψ(n, 3) = 2 n · (2n − 1)(2 n − 2)6− 3 n + 2 n ,− 6 n + 5 n + 4 n − 3 n .The general procedure **of** obta**in****in**g **the** formula for ψ(n, k) with k fixed was presentedby Kilibarda i Jovoviæ **in** [22] (2003). They showed formulas for n 10. Theproblem was reduced to **the** issue **of** count**in**g bipartite graphs with fixed **number** **of**vertices and edges and **number** **of** 2-colour**in**g **of** determ**in**ed type. The generalization**of** this method can be found **in** [23].The difficulty is that **the** **number** **of** sets form**in**g **the** anticha**in** – on **the** basis **of**Sperner’s **the**orem cited below – can be very large.Def**in**ition 17 (Sperner family). Sperner family **of** subsets **of** set X is an anticha**in****in** **the** partially ordered set (P (X), ⊆) (where P (X) denotes **the** family **of** all subsets**of** X).Theorem 18. If A is a Sperner family **in** set X **the**n( ) |X||A| .⌊|X|/2⌋8. Connection between Dedek**in**d problem and **number** **of** **cluster ings**problemWe will show how Dedek

1541. with elements hav**in**g nonempty **in**tersections, i.e.A 1 (n) = {A ∈ A(n) : ∃ a,b∈A a ∩ b ≠ ∅}.Among **the**m we will dist**in**guish an-We will denote its **number** by ψ 1 (n).ticha**in**s:• not conta**in****in**g s**in**gletons (=: ψ 11 (n))• conta**in****in**g s**in**gletons (=: ψ 12 (n))2. with disjo**in**t elements (=: ψ 2 (n)).The total **number** **of** anticha**in**s will take formψ(n) = ψ 1 (n) + ψ 2 (n) = ψ 11 (n) + ψ 12 (n) + ψ 2 (n).8.2. Number **of** anticha**in**s **of** each type8.2.1. ψ 11(n)ψ 11 (n) determ**in**es **the** **number** **of** anticha**in**s **in** which at least two elements havenonempty **in**tersection and no element is a s**in**gleton. Such families satisfy **the** proper**cluster ings**conditions with various K and J.When K is determ

1558.2.2. ψ 12(n)Element belong**in**g to s**in**gleton – from anticha**in** def**in**ition – can not belong to itsany o**the**r elements. Because **of** that fact **the** only th**in**g to do to determ**in**e ψ 12 (n)with i s**in**gletons (i = 1 . . . n) is to multiply **the** **number** **of** possible choices **of** is**in**gletons by ψ 12 (n − i) (**the** **number** **of** anticha**in**s with no s**in**gletons for properlyreduced set):ψ 12 (n) ==( ( )( n n nψ 11 (n − 1) + · · · + ψ 11 (n − i) + · · · + ψ 11 (0) =1)i n)n∑i=1( ni)ψ 11 (n − i). (15)8.2.3. ψ 2(n)The last group **of** anticha**in**s is formed by families which elements have no **in**tersections.These can be counted easily us**in**g **the** formula for **the** **number** **of** partitions **of**k-element set (B k denotes Bell **number**):ψ 2 (n) ==( ( ) ( n n nB 1 + · · · + B i + · · · + B n =1)i n)n∑i=1( ni)B i . (16)In above sum i denotes **the** **number** **of** elements covered by anticha**in**.8.3. F**in**al formulaJo**in****in**g above formulas toge**the**r we obta**in**:ψ(n) = ψ 11 (n) + ψ 12 (n) + ψ 2 (n) ==n∑( ) n ∑ N n∑( ) nn∑( ) nϑ(i, j) + ψ 11 (n − i) + B i =ii ii=3 j=2i=1i=1n∑( ) n ∑ N n∑( ) ⎡ ⎤n ∑( )=ϑ(i, j) + ⎣n−**in** − i ∑ Nϑ(k, j) + B i⎦ , (17)ii ki=3j=2where B i – is i-th Bell **number**.i=1k=3j=2

1569. F**in**al remarksIn this paper we presented a method for count**in**g all proper **cluster ings** for a

157[12] Yamamoto K. A.; Logaritmic order **of** free distributive lattice, J. Math. Soc. Japan,6(3–4), 1954, pp. 343–353.[13] Korobkov B. K.; **On** monotone functions **in** Boolean algebra (**in** Russian), ProblemyKibernet., 13, 1965, pp. 5–28.[14] Hansel G.; Sur le nombre des fonctions boolennes monotones de n variables, C.C.Acad. Sci Paris, 262(20), 1966, pp. 1088–1090.[15] Kleitman D.; **On** Dedek**in**d’s problem: The **number** **of** monotone Boolean functions,Proc. Amer. Math. Soc., 21, 1969, pp. 677–682.[16] Korshunov A. D.; The **number** **of** monotone Boolean functions, Problemy Kibernet.,38, 1981, pp. 5–108.[17] Kisielewicz A.; A solution **of** Dedek**in**d’s problem on **the** **number** **of** isotone Booleanfunctions, Journal für die Re**in**e und Angewandte Ma**the**matik, 386, 1988, pp. 139–144.[18] Tombak M., Isotam A., Tamme T.; **On** Logical Method for Count**in**g Dedek**in**d Numbers,Lecture Notes **in** Computer Science, 2138, 2001, pp. 424–427.[19] Church R.; Enumeration by rank **of** **the** elements **of** **the** free distributive lattice withseven generators, Not. Amer. Math. So., 12, 1965, pp. 724.[20] Wiedemann D.; A computation **of** **the** eighth Dedek**in**d **number**, Order, 8, 1991, pp. 5–6.[21] Dedek**in**d’s Problem. Available via http://www.mathpages.com/home/kmath030.htm.[22] Kilibarda G., Jovović V.; **On** **the** **number** **of** monotone Boolean functions with fixes**number** **of** lower units (**in** Russian), Intellektualnye sistemy, 7, 2003, pp. 193–217.[23] Kilibarda G., Jovović V.; Anticha**in**s **of** Multisets, Journal **of** Integer Sequences, 7,2007.Received September 30, 2010